// omentialvo

#include "f_rpass.h" 
#include "s_rpass.h" 
#include "s_androids.h" 
#include "f_androids.h" 
#include "slang.h" 

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>

#include <time.h>
#include <ctype.h>
extern char *sname(char *);
char *pname = "skeleton.pass";
char *bname = "skeleton.base";

static char *key;
static char *body;

struct word;
struct frames;
struct con; 

enum {
	NOTHING,
	ANSWER = 0,
	KEY_WORD
};
extern int findcolor();
extern struct frames *read_dvd(char *name);
extern void smalling(char *s);

// zdarzyo si tak e tutaj osiedliy sie funkcje ..					//


//-------------------------------------------------------------------------------------
static struct con *init_con()
{
	struct con *p = malloc(sizeof(struct con));
	p->first = p->last = p->current = 0;
	p->kw = 0;
	p->next = 0;

	return p;
}

//-----------------------------------------------------------------------------------
struct word *init_word(char *what)
{
	struct word *w = malloc(sizeof(struct word));
	w->what = what;
	w->next = 0;
	return w;
}

//-------------------------------------------------------------------------------------
char *read_word(FILE *fd, char* to_mask)
{
#define W2 40
	int c = fgetc(fd), width = W2, place = 0;
	char *start = malloc(sizeof(char) * width);
	while (c && c != EOF && !strchr(to_mask,c)) {
		if (place >= width-2)
			start = realloc(start,(width *= 2)+1);
		start[place++] = c;
		c = fgetc(fd);
	}
	start[place] = '\0';
	if (place || c != EOF)
		return start;
	return 0;
}

//-------------------------------------------------------------------------------------
static int set_words(char *whole)
{
	int i;
	while (isspace(*whole) && *whole)
		whole++;
	for (i = 0; whole[i] != ' ' && whole[i]; i++)
		;		
	if (!i)
		return 0;
	body = whole+i+1;
	whole[i] = '\000';
	key = whole;
	return 1;
}

/************************************************************************
 * 
 * 				K E Y W O R D
 * 				
 ************************************************************************/
//----------------------------------------------------------------------------------
static struct keyw *init_kw()
{
	struct keyw *w = malloc(sizeof(struct keyw));
	w->first = w->last = 0;
	w->n = 0;
	return w;
}

//----------------------------------------------------------------------------------
static void put_kw(struct keyw *k, char *what)
{
	if (!k->first)	
		k->first = k->last = init_word(what);
	else {
		k->last->next = init_word(what);
		k->last = k->last->next;
	}
	k->n++;
}

//----------------------------------------------------------------------------------
static void add_keyword(char *what, struct android *andek, int old)
{
	if (!andek->first) {
		andek->first = andek->last = init_con();
	} else if (!old) {
		andek->last->next = init_con();
		andek->last = andek->last->next;
	}
	if (!andek->last->kw)
		andek->last->kw = init_kw();
	put_kw(andek->last->kw,what);	
//	fprintf(stderr,"Normal Key word:\t\"%s\"\n",what);
}



/************************************************************************
 * 
 * 				A N S W E R
 * 				
 ************************************************************************/
static struct ans *init_ans()
{
	struct ans *a = malloc(sizeof(struct ans));
	a->first = a->last = 0;
	a->next = 0;
	a->n = 0;
	return a;
}

//----------------------------------------------------------------------------------
static void put_ans(struct ans *a, char *what)
{
	if (!a->first) {
		a->first = a->last = init_word(what);
	} else {
		a->last->next = init_word(what);
		a->last = a->last->next;
	}
	a->n++;

}

//----------------------------------------------------------------------------------
static void add_answer(char *answer, struct android *andek, int new)
{
	if (!andek->last->first)
		andek->last->first = andek->last->last = andek->last->current = init_ans();
	else if (new) {
		andek->last->last->next = init_ans();
		andek->last->last = andek->last->last->next;
	}
	put_ans(andek->last->last, answer);

//	fprintf(stderr,"\t\tAnswer:\t\"%s\"\n",answer);
}

//----------------------------------------------------------------------------------
static void init_andek(struct android *andek)
{
	andek->first = andek->last = 0;	
	andek->l_other = andek->f_other = 0;
	andek->n_other = 0;
	andek->app = "normal.app";
	andek->passname = pname;
	andek->basename = bname;
	andek->mood = FRIENDLY;
}

// ------------------------------------------------------------------------------------//
char *add_android(FILE * fd, struct android *andek)
{
	int name = 0, line, state = NOTHING, new = 0;
	char *whole, *msg = 0; 
	init_andek(andek);
	for (whole = read_word(fd, "\n"), line = 1;
			whole && !msg; whole = read_word(fd, "\n"), line++) {
		if (!set_words(whole) || *key == '#')
			continue;
		if (*key != '@')
			msg = pprintf("You forgot about @", "");
		else {
			key++;			
			if (!strcmp("name", key)) {
				if (name)
					msg = pprintf("who are %s ?\n\t"
							"This android already has name",
							body);
				else {
					andek->name = body;
					name++;
				}
			} else if (!strcmp("deep", key)) {	//      @word ;)  des key word
				new = 1;
			} else if (!strcmp("word", key)) {	//      @word ;)  des key word
				add_keyword(body, andek, state);
				state = KEY_WORD;
			} else if (!strcmp("base", key)) {	//      @pass
				andek->basename = body;
			} else if (!strcmp("pass", key)) {	//      @pass
				andek->passname = body;
			} else if (!strcmp("mood", key)) {	//      @pass
				switch (tolower(*body)) {
				case 'h' :
					andek->mood = HOSTILE;
					break;
				case 'n' :
					andek->mood = NEUTRAL;
					break;
				default :
					andek->mood = FRIENDLY;
					break;
				}
			} else if (!strcmp("answer", key)) {	//      @answer ;)
				add_answer(body, andek, new);
				state = ANSWER;
				if (new)
					new--;
			} else if (!strcmp("other", key)) {	//      @answer ;)
				if (!andek->f_other)
					andek->l_other = andek->f_other =
						init_word(body);
				else {
					andek->l_other->next =
						init_word(body);
					andek->l_other =
						andek->l_other->next;
				}
				andek->n_other++;
			} else if (!strcmp("app", key))
				andek->app = body;
			else {
				msg = pprintf("Undeclared key_word \"%s\"", key);
			}
		}
	}
	andek->crosser = add_passbot(andek->passname, strcmp(andek->passname, pname));
	andek->brosser = add_base(andek->basename, strcmp(andek->basename, bname));
	if (msg) {
		fprintf(stderr, "in lines %d is ", line);
		return strdup(msg);
	}
	return msg;
}

//-------------------------------------------------------------------------------------
struct register_andro *init_spy(struct android *joe)
{
	struct register_andro *s = malloc(sizeof(struct register_andro));
	s->next = 0;
	s->who = joe;	
	return s;
}

//-------------------------------------------------------------------------------------
int read_andek_dvd(char *name, struct android *joe)
{
	joe->dvd = read_dvd(name);	
	if (joe->dvd)
		return 1;
	return 0;

}

//-------------------------------------------------------------------------------------

int d(int hm)
{
	if (hm)
		return (rand() % hm) + 1;

	abort();
}

//-------------------------------------------------------------------------------------
static char *some_answer(struct word *w, int n)
{
	if (w) {
		n = d(n);	
		while (--n && w->next)
			w = w->next;
		return w->what;
	} 
	return strdup("yyy ?!");
}

//-------------------------------------------------------------------------------------
void change_character(struct android *andek, int i)
{
	if ((i == -1 && andek->mood) || (i == 1 && andek->mood != FRIENDLY))
			andek->mood += i;
}
//-------------------------------------------------------------------------------------
char *find_word(struct android *who, char *what) 
{
	struct con *jmp;
	struct word *w;
	smalling(what);
	for (jmp = who->first; jmp; jmp = jmp->next)
		for (w = jmp->kw->first; w; w = w->next)  {
			smalling(w->what);
			if (strstr(what, w->what)) {
				char *an = some_answer(jmp->current->first, jmp->current->n); 
				if (jmp->current->next)
					jmp->current = jmp->current->next;
				return an;
			}
		}
	return 0;
}

//-------------------------------------------------------------------------------------
char *android_chat(struct android *who, char *p)
{
	char *what = find_word(who,p);
	if (what)
		return what;
	else
		return 0;//some_answer(who->f_other,who->n_other);
}	

