#include "s_window.h"
#include "s_menu.h"
#include "s_button.h"
#include "slang.h"
#include "vigets_configure.h"

#include <stdlib.h>

//	-------------------	------------------	-----------------	//
int action(struct button *b)
{
	return b->action();
}

//	-------------------	------------------	-----------------	//
static struct button *init_button(struct menu *m, struct window *w, char *n, int (*f)())
{
	#define SPACE_BETWEEN 2 
	struct button *i = malloc(sizeof(struct button));
	i->next = 0;
	i->action = f;
	if (n)
		i->name = n;
	else
		i->name = "Empty name";
	if (m) {
		if (!m->f_click) {
			i->x = m->mama->x +m->x;   
			i->y = m->mama->y +m->y+ m->height;
		} else {
			i->x = m->l_click->x+ SPACE_BETWEEN+ m->l_click->width;
			i->y = m->l_click->y;
			if ((i->x + (int)strlen(i->name)) > sl_screen_width-1) {
				i->x = m->f_click->x;
				i->y = m->f_click->y +4; 
			}
				
		}
	} else if (w) {
		if (!w->f_click) {
			i->x = w->x;  
			i->y = w->y + w->height;
		} else {
			i->x = w->l_click->x + w->l_click->width + SPACE_BETWEEN; 
			i->y = w->l_click->y;
			if ((i->x + (int)strlen(i->name)) > sl_screen_width-1) {
				i->x = w->f_click->x;
				i->y = w->f_click->y +4; 
			}
		}
	
	}
	i->width = strlen(i->name)+4;
	return i;		
}

//	-------------------	------------------	-----------------	//
void add_button(struct menu *m, struct window *w, char *name, int (*f)())
{
	struct button *i = init_button(m, w, name, f);
	if (m) {
		if (!m->f_click) {
			m->f_click = m->l_click = i;
			m->c_click = 0;
		} else {
			m->l_click->next = i;
			m->l_click = m->l_click->next;
		}
	} else if (w) {
		if (!w->f_click) {
			w->f_click = w->l_click = i;
			w->c_click = 0;
		} else {
			w->l_click->next = i;
			w->l_click = w->l_click->next;
		}

	}
}

//	-------------------	------------------	-----------------	//
void draw_buttons(struct button *f, struct button *c)
{
	struct button *jmp;
	for (jmp = f; jmp; jmp = jmp->next) {
		sl_color(Passive);
		sl_frame(jmp->x, jmp->y, jmp->width, 3);
		sl_goto(jmp->x+1, jmp->y+1);
		if (jmp == c)
			sl_color(Active);
		else
			sl_color(Passive);
		sl_addstrn(jmp->name, jmp->width-3);
		if (jmp == c)
			sl_putch(CH_CURRENT_SHOW);
		else
			sl_putch(' ');
		
	}
}
