#include "slang.h"
#include "stuff.h"

#include "f_dvd.h"
#include "f_androids.h"

#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#define T1 Lcyan
#define T2 Lblue
#define T3 Lwhite


struct fr_line;
struct fr_line {
	char *caption;
	struct fr_line *next;
};

struct frame {
	struct fr_line *first, *last;
	struct frame *next; 
	int height;
};

struct frames {
	struct frame *first ,*last, *current;
	int lo, ro;	//left and right offset
	int width;
};




//	-------------------	------------------------	---------------		//
static struct frames *init_frames()
{
	struct frames *f = malloc(sizeof(struct frames));
	f->first = f->last = f->current = 0;	
	return f;
}

//	-------------------	------------------------	---------------		//
static struct frame *init_frame()
{
	struct frame *f = malloc(sizeof(struct frame));
	f->first = f->last = 0;
	f->next = 0;
	return f;
	
}

//	-------------------	------------------------	---------------		//
static void add_frame(struct frames *f)
{
	if (!f->first) 
		f->first = f->last = f->current = init_frame();
	else {
		f->last->next = init_frame();
		f->last = f->last->next;
	}
}

//	-------------------	------------------------	---------------		//
static struct fr_line *init_line(char *c) 
{
	struct fr_line *frl = malloc(sizeof(struct fr_line));
	frl->next = 0;
	frl->caption = c;
	return frl;
}

//	-------------------	------------------------	---------------		//
static void add_line(struct frame *f, char *c)
{
	if (!f->first)
		f->first = f->last = init_line(c); 
	else {
		f->last->next = init_line(c);
		f->last = f->last->next;
	}
	
}

//	-------------------	------------------------	---------------		//
static void rewrite(struct frames *dvd, int length)
{
	char *cor = malloc(sizeof(char) * (length+1));
	struct fr_line *l;
	struct frame *f;
	for (f = dvd->first; f; f = f->next) 
		for (l = f->first; l;  l = l->next) {
			sprintf(cor,"%s%*s",l->caption, (length-strlen(l->caption)), "");
			free(l->caption);
			l->caption = strdup(cor);
		}
	
}

//	-------------------	------------------------	---------------		//
static void check_width(struct frames *dvd)
{
	struct fr_line *l;
	struct frame *f;
	int w, tmpw, d = 0, lines = 0, h;

	for (w = strlen(dvd->first->first->caption), 
		d = 0, f = dvd->first; f; f = f->next) {
		
		for (h = 0, l = f->first; l; l = l->next, lines++, h++) {
			tmpw = strlen(l->caption);
			if (tmpw != w) {
				if (tmpw > w) {
					w = tmpw;
				}
				d = 1;
			}
		}
		f->height = h;
	}				
	if (d) 
		rewrite(dvd, w);
	dvd->width = w;
}

//	-------------------	------------------------	---------------		//
struct frames *read_dvd(char *name)
{
	FILE *fd = fopen(name, "r");
	if (!fd) {
		fprintf(stderr,
			"#@! B L A H  pendant ouvrir la file %s dans ton ordianture\n",
			name);
		fclose(fd);
		return 0;
	} else {
		struct frames *dvd = init_frames();
		int lines = 0;
		char *w ="ciocia";//= read_word(fd, "\n");

		for (; w; w = read_word(fd, "\n"), lines++) {
			if (strstr(w, "@nex") || !dvd->first) {
				w = read_word(fd,"\n");
				add_frame(dvd);
			}
			add_line(dvd->last, w);
		}
		fclose(fd);
		check_width(dvd);
		return dvd;
	}
}

//	-------------------	------------------------	---------------		//
void draw_teleport(struct frames *dvd, int sx, int y)
{
	struct fr_line *w;
	char *l;
	int in, x, sy = y;
	for (w = dvd->current->first; w; w = w->next, y++) 
	
		for (in =0, l = w->caption, x = 0; 
			*l; l++, x++) {
			if (y == sy && *l == ' ' && in)
				in = 0;
			if (*l == ' ' && !in) 
					continue;
			else if (*(l+1))
				if (*l != ' ' && *(l+1) == ' ')
					in = (in) ? 0 : 1;
			sl_goto(sx + x, y);
			switch(d(3)) {
			case 1:
				sl_color(T1);
				break;
			case 2:
				sl_color(T2);
				break;
			case 3:
				sl_color(T3);
				break;
			}
			sl_putch(*l);
		}
}

//	-------------------	------------------------	---------------		//
static void draw_right(struct frames *dvd, int sx, int y)
{
	struct fr_line *w;
	char *l;
	int in, x, sy = y;
	for (w = dvd->current->first; w; w = w->next, y++) 
	
		for (in =0, l = w->caption, x = 0; 
			*l; l++, x++) {
			if (y == sy && *l == ' ' && in)
				in = 0;
			if (*l == ' ' && !in) 
					continue;
			else if (*(l+1))
				if (*l != ' ' && *(l+1) == ' ')
					in = (in) ? 0 : 1;
			sl_goto(sx + x, y);
			sl_putch(*l);
		}
}

//	-------------------	------------------------	---------------		//
static void draw_left(struct frames *dvd, int sx, int y)
{
	struct fr_line *w;
	int i, in, x, vi = dvdlen(dvd)-1 ,sy = y;
	char *l;
	for (w = dvd->current->first; w; w = w->next, y++) 
		for (l = &w->caption[vi], i = vi, in = 0, x = 0; 
			i+1; x++, i--, l--) {
			if (y == sy && *l == ' ' && in)
				in = 0;
				
			if (*l == ' ' && !in) 
					continue;
			else if (*(l+1))
				if (*l != ' ' && *(l+1) == ' ')
					in = (in) ? 0 : 1;
			sl_goto(sx + x, y);
			sl_putch(*l);
		}
		
}

//	-------------------	------------------------	---------------		//
void draw(struct frames *dvd, int sx, int y, int curse)
{
	if (curse == right)
		draw_right(dvd, sx, y);
	else if (curse == left) 
		draw_left(dvd, sx, y);
	
}

//	-------------------	------------------------	---------------		//
void setaf(struct frames *dvd)
{
	dvd->current = dvd->first;
}

//	-------------------	------------------------	---------------		//
int dvdhei(struct frames *dvd)
{
	return dvd->current->height;
}

//	-------------------	------------------------	---------------		//
int dvdlen(struct frames *dvd)
{
	return dvd->width;
}
//	-------------------	------------------------	---------------		//
int isfirst(struct frames *dvd)
{
	if (dvd->current == dvd->first)
		return 1;
	return 0;
}

//	-------------------	------------------------	---------------		//
int islast(struct frames *dvd)
{
	if (!dvd->current->next)
		return 1;
	return 0;
}
//	-------------------	------------------------	---------------		//
void prevf(struct frames *dvd)
{
// don`t ask me why  ...
	struct frame *j;
	for (j = dvd->first; j->next && j->next != dvd->current; j = j->next);
	dvd->current = j;
	
}

//	-------------------	------------------------	---------------		//
void nextf(struct frames *dvd)
{
	dvd->current = dvd->current->next;
	if (!dvd->current)
		dvd->current = dvd->first;
}

//	-------------------	------------------------	---------------		//
void putro(struct frames *dvd, int r)
{
	dvd->ro = r;
}

//	-------------------	------------------------	---------------		//
void putlo(struct frames *dvd, int l)
{
	dvd->lo = l;
}

//	-------------------	------------------------	---------------		//
int dvdro(struct frames *dvd)
{
	return dvd->ro;
}

//	-------------------	------------------------	---------------		//
int dvdlo(struct frames *dvd)
{
	return dvd->lo;
}

