#include <sys/types.h>
#include <sys/stat.h>
 
#include <dirent.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>

#include "ematrix.h"
#include "slang.h"
#include "stuff.h"

#include "f_androids.h"
#include "f_dvd.h"
#include "f_map.h"
#include "f_me.h"


#include "s_androids.h"
#include "s_me.h"

#include "f_window.h"


// window config ::: ;)
#define Y 0
#define X 1
#define TO_Wall 6	// space between wall and window |   |  
#define IRC_H 5
#define MSG_H 3
#define IRC_TITLE ":[Sobriost .]."  
#define MSG_TITLE "[(msg)]" 

extern char *sname(char *p1,char *p2);
extern int skeyboard(char *what, int no, int sh, int x, int y);
extern void intro(void);

static char *andek_dir = "people";
static char *app_dir = "app";
static char end_msg[] = " Q U E N D I  [GNU/GPL]"; 
struct androids *quena;
struct window *IRC, *MSG;
char *start = 
"Uruchamiasz _q_u_e_n_d_i po raz pierwszy. \n"
"Chcialem _C_i_e powiadomi_c _ze najbardziej lubi by_c u_zywane \n"
"w rozdzielczo_sci _1_0_0x_3_7 lub wy_zszej _:_D \n"
" \nDzi_ekuje serdecznie za uwag_e \n"
"pe_.es \n"
"        _Zycz_e mi_lego dnia, \n"
"        Chyba _ze masz inne plany _;_)";

line *lines;

int init_quena();

//	-----------------	----------------	----------------	//
int init_stuff()
{
	
	if (init_quena()) {
		sl_init();
		srand(time(0) ^ getpid());
		sl_cls();
		if (!mkdir(sname(getenv("HOME"),".quendi"), 0777)) {
		
			skeyboard("_D z i e n   _D o b r y  _!", 
				Green, Lgreen, 5, sl_screen_height/2 - 4);
			skeyboard(start, Green, Lgreen, 5, sl_screen_height/2);
			sleep(2);
		}	
		sl_cls();
		return 1;
	}
	return 0;

}

//	-----------------	----------------	----------------	//
int bye()
{
	
	sl_fini();
	fprintf(stderr,"\n%s\n...\n",end_msg);
	return 1;
}

//	-----------------	----------------	----------------	//
void init_windows()
{
			
	IRC = init_window(X, Y, sl_screen_width-TO_Wall, IRC_H, IRC_TITLE); 
	MSG = init_window(X,Y+IRC_H, sl_screen_width-TO_Wall, MSG_H, MSG_TITLE);
	
}

//	-----------------	----------------	----------------	//
void init_ematrix()
{
	line *j;
	int i;
	lines = malloc(sizeof(line) * (sl_screen_width + 2));
	for (i = 0, j = &lines[0]; i < sl_screen_width; i++, j++) 
		setl(j, 1, sl_screen_height);	
}

//	-----------------	----------------	----------------	//
void draw_bgd(int w, int h)
{
	draw_ematrix(0, 0, h, w, &lines[0], &lines[w-1]); 
}

//	-----------------	----------------	----------------	//
int ia()
{
	if (init_stuff()) {	
		struct earthsee *roke;
		struct me * ged;
		
		init_ematrix();
		init_windows();
		
		roke = init_earthsee(quena->n_andro);	
		put_androids(roke, quena->first);
		sort_androids(quena->first);
		ged = init_me(retf(roke));
		intro();
		while (get_key(ged)) {
		
			draw_bgd(sl_screen_width, sl_screen_height); 
			draw_me(ged);
			draw_window(IRC);
			draw_window(MSG);
		
			sl_refresh();
			usleep(60000);
		}	
		return bye();
	}
	return 1;
}

//	-----------------	----------------	----------------	//
int init_quena()
{
	DIR *where;
	struct dirent *jumper;
	struct android *joe;
	char *c, *name = 0;
	quena = malloc(sizeof(struct androids));
	quena->n_andro = 0;
	where = opendir(andek_dir);
	if (!where) {
		chdir(PREFIX);
		where = opendir(andek_dir);
	} 
	if (!where) {
		fprintf(stderr,"Couldn`t open dir %s and %s/%s",andek_dir,PREFIX,andek_dir);
		abort();
	}
	chdir(andek_dir);
	while ((jumper = readdir(where))) {
		if (*jumper->d_name == '.' || !strcmp("core", jumper->d_name) ||
			!strcmp(app_dir,jumper->d_name)) 
			continue;
		joe = malloc(sizeof(struct android));
		joe->file_name = jumper->d_name;
		free(name);
		name = malloc(sizeof(char) * (strlen(jumper->d_name) +2)); // for / and \000
		sprintf(name,"%s",joe->file_name);
		printf("\n\n%s file:\n", jumper->d_name);
		c = add_android(fopen(name, "r"), joe);
		if (c) {
			printf("bad magic word:\t%s\n", c);
			return 0;
		}
		printf("ok. ;(\n");
		quena->n_andro++;
		free(name);
		name = malloc(sizeof(char) * (strlen(app_dir) + strlen(joe->app) + 2));
		sprintf(name,"%s/%s",app_dir, joe->app);
		if (!read_andek_dvd(name, joe))
			return 0;
		if (!quena->first)
			quena->first = quena->last = quena->joe = init_spy(joe);
		else {
			quena->last->next = init_spy(joe);
			quena->last = quena->last->next;
		}
	}
	chdir("..");
	return 1;
}

//	-----------------	----------------	----------------	//
int main()
{
	return ia();
}

