#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "configure.h"

#include "slang.h" 
#include "stuff.h"

#include "f_dvd.h"
#include "f_map.h"
#include "f_me.h"
#include "f_window.h"
#include "f_androids.h"
#include "f_inter.h"
#include "f_rpass.h" 
#include "f_rbase.h"

#include "s_me.h"
#include "s_rpass.h" 
#include "s_androids.h"
#include "s_window.h"

#include "teleport.h"

#define ROOT_NAME "alan" // how many bright will be done before i move my body
#define BRIGHT 3 // how many bright will be done before i move my body
static const char *quit = "bye";
extern int bye();
static char * me_name = "alan/alan.app";
static char * teleprt_name = "people/app/teleport.app";
static int bright = BRIGHT;
static struct android *andek; 
extern struct window *MSG;
extern struct window *IRC;

//	----------------	------------------	-------------------	//
static void set_map_state(struct me *i)
{
	if (i->x < sl_screen_width/2) 
		i->map_state = BEFORE;

	else if (i->x < maplen(i->way) - sl_screen_width/2) 
		i->map_state = MEDLE;	
	else
		i->map_state = AFTER;
}

//	----------------	------------------	-------------------	//
struct me *init_me(struct map *m)
{
	struct me *i = malloc(sizeof(struct me));

	if (access(me_name,R_OK)) {
		chdir(PREFIX);
		if (access(me_name,R_OK)) {
			fprintf(stderr,"Couldn`t open file %s and %s/%s",me_name, PREFIX, me_name);
			abort();
		}
	}	
	i->normal = read_dvd(me_name);
	i->teleport = read_dvd(teleprt_name);
	i->dvd = i->normal;
	i->x = 1;
	i->y = Map_height - dvdhei(i->dvd);
	i->way = m;
	i->state = stand;
	i->curse = right;
	i->name = "blue";
	set_map_state(i);	
	return i;
}

//	----------------	------------------	-------------------	//
static int check_bright()
{
	if (!--bright) {	
		bright = BRIGHT;
		return 1;
	}
	return 0;

}

//	----------------	------------------	-------------------	//
void test_teleport(int curse, struct me *i)
{
	if (curse == left && i->x > to_T && i->x < to_T + T_length/3 - 2) { // ;)
		if (p_map(i->way)) {
			i->nway  = p_map(i->way);
			i->nx = maplen(i->nway) - 4 - dvdlen(i->dvd) - to_T;
			i->dvd = i->teleport;
			i->state = disapear;
			i->curse = left;
		}
	} else if (curse == right && i->x > maplen(i->way)-to_T - T_length) {
		if (n_map(i->way)) {
			i->nway = n_map(i->way);
			i->nx = to_T + T_length/2;
			i->dvd = i->teleport;
			i->state = disapear;
			i->curse = right;
		}
	}
}

//	----------------	------------------	-------------------	//
void move_me(int curse, struct me *i)
{	

	if (curse == left) {
		if (i->x-1 > 1) { //wall # 
			i->x--;
			i->state = go;
			i->curse = left; 
		}
	} else {
		if (i->x + dvdlen(i->dvd)+1 < maplen(i->way)-1) { // wall #
			i->x++;
			i->state = go;
			i->curse = right;
		}
	}
	if (check_bright())
		nextf(i->dvd);

	test_teleport(curse,i);		

}

//	----------------	------------------	-------------------	//
int seeya(char *msg)
{
	sl_fini();
	fprintf(stderr,"sory ... but : %s", msg);
	abort();
	return 1;
}

//	----------------	------------------	-------------------	//
int ret_ex(struct me *i)
{
	switch (i->map_state) {
		case BEFORE :
			return sl_screen_width;
		case MEDLE :
			return i->x+sl_screen_width/2; 
		case AFTER :
			return i->x + (maplen(i->way) - i->x); 
	}
	return seeya("unknown map_state"); 
}

//	----------------	------------------	-------------------	//
int ret_sx(struct me *i)
{
	switch (i->map_state) {
		case BEFORE :
			return 0;
		case MEDLE :
			return i->x-sl_screen_width/2;
		case AFTER :
			return i->x - (sl_screen_width-((maplen(i->way) - i->x)));
	}
	return seeya("unknown map_state"); 
}

//	----------------	------------------	-------------------	//
int see_andek(struct me *i)
{
	struct register_andro *a = anyone(i->way, ret_sx(i), ret_ex(i), i->x + dvdlen(i->dvd)/2);
	if (!a)
		return 0;
	andek = a->who;
	if (andek->curse == i->curse)
		andek->curse = (i->curse == left) ? right : left;
	nextf(andek->dvd);
	return 1;
}

//	----------------	------------------	-------------------	//
void send_nick(struct window *des, char *n, int op) 
{
	window_key(des,'\n');
	window_key(des,'<');
	if (op)
		window_key(des,'@');
	while (*n)
		window_key(des,*n++);
	window_key(des,'>');
	window_key(des,' ');

}

//	----------------	------------------	-------------------	//
void send_words(struct window *des, char *w)
{
	while (*w)
		window_key(des,*w++);

}

//	----------------	------------------	-------------------	//
char *read_chs(struct window *win, char *src) 
{
	struct line *l;
	char *des = src, *s;
	int p;
	for (l = win->first; l; l = l->next) {
		if (l->place)
			for (p = 0, s = l->caption; *s && p <= l->place; p++) 
				*des++ = *s++;
	}
	*des = '\000';
	return src;
}

//	----------------	------------------	-------------------	//
int count_chs(struct window *WEE) 
{
	struct line *l;
	char *s;
	int p, x = 0;
	for (x = 0, l = WEE->first; l; l = l->next)  
		if (l->place) 
			for (p = 0, s = l->caption; *s && p <= l->place; s++, x++, p++);
	return x;
}

//	----------------	------------------	-------------------	//
int send_ask(struct window *src, struct window *des, struct me *i)
{
	int msg_len = count_chs(src);
	if (msg_len && (see_andek(i) || src->first->caption[0] == '/')) {
		char *msg = malloc(sizeof(char) * msg_len+1);
		msg = read_chs(src, msg);
		if (*msg == '/') {
			
			if (strstr(msg,quit) || (andek && wdefin(BYE, msg, andek->brosser)))
				return spadam;
			send_nick(des,ROOT_NAME,1);
			send_words(des,"forbiden spell &-(");

		} else if (andek) {
			char *tmp = msg;
			send_nick(des,i->name,0);
			while (*tmp)
				window_key(des, *tmp++);

			send_nick(des, andek->name,1);
			send_words(des, inter_sentence(andek, msg));
		}
	}
	return 1;
}

//	----------------	------------------	-------------------	//
int ctrl(struct me *i, int k)
{
	if (k == '\n') {
		if (MSG->current->place > 0) { 
			if (!send_ask(MSG, IRC, i))
				return 0;
			clear_window(MSG);			
		}
	} else {
		window_key(MSG, k);
	}
	return 1;
}

//	----------------	------------------	-------------------	//
int get_key(struct me *i)
{
	if (i->state == disapear || i->state == apear) // linux kernel rocks :)
		goto end;
	else {	
		int c = 0, m = 0;
		do {
			c = sl_getch();
			if (c)
				m = c;
		} while (c);
		if (m) {
			switch (m) {
				case 'P':
					if (p_map(i->way)) {
						i->nway  = p_map(i->way);
						i->nx = maplen(i->nway) -4 - dvdlen(i->dvd);
						i->dvd = i->teleport;
						i->state = disapear;
					}
					break;
				case 'N':
					if (n_map(i->way)) {
						i->nway = n_map(i->way);
						i->nx = 4;
						i->dvd = i->teleport;
						i->state = disapear;
					}
					break;
				case sl_key_left:
					move_me(left, i);
					break;
				case sl_key_right:
					move_me(right, i);
					break;
				case sl_key_esc:
					return 0;	
					break;
				default :
					if (!ctrl(i, m))
						return spadam;

			}
		} else 
			i->state = stand;
	}
end :
	return i->state;	
}

//	----------------	------------------	-------------------	//
void draw_M(struct frames *dvd, int x, int y, int course, struct me *i) // misc
{
	switch (i->state) {
		case disapear :
			if (islast(i->dvd)) {
				i->state = apear;
				i->way = i->nway;
				i->x = i->nx;
			} else {
				nextf(i->dvd);
				draw_teleport(i->dvd, x, y-1);
			}
			break;
		case apear:
			if (isfirst(i->dvd)) {
				i->state = stand;
				i->dvd = i->normal;

			}
			else {
				prevf(i->dvd);
				draw_teleport(i->dvd, x, y-1);
			}
			break;
		default:
			sl_color(mapcolor(i->way));
			draw(dvd, x,  y, course);
			break;
	}


}

//	----------------	------------------	-------------------	//
void draw_me(struct me *i)
{
	int tmp ;
	set_map_state(i);
	draw_map(i->way, ret_sx(i), ret_ex(i), i->y + dvdhei(i->normal)-1);

	switch (i->map_state) {
		case BEFORE :
			draw_M(i->dvd, i->x,  i->y, i->curse, i);
			break;
		case MEDLE :
			draw_M(i->dvd, sl_screen_width/2 ,  i->y, i->curse, i);

			break;
		case AFTER :
			tmp = (maplen(i->way) - i->x);
			draw_M(i->dvd, sl_screen_width-tmp,  i->y, i->curse, i);

			break;	
	}
}
