#include <stdlib.h>

#include "f_button.h"
#include "slang.h"
#include "s_menu.h"
#include "s_button.h"
#include "vigets_configure.h"

struct mather *mama;

// deklaravj 
static struct menu*init_menu(char *name, int x, int y, int height);
static struct item*init_item(struct menu *m, char *n, int (*f)());
static int put_x(int x);
static int put_y(int y);
static int put_width(int width);
static int put_height(int height);

/*    ******  ********   ** *	         mather stuff			*******  ******** *    */ 
struct mather *init_mather(void)
{
	struct mather *mama = malloc(sizeof(struct mather));	
	mama->x = MATHER_X;
	mama->y = MATHER_Y;
	mama->width = MATHER_WIDTH;
	mama->height = MATHER_HEIGHT;
	mama->current = mama->f_menu = mama->l_menu = 0;
	return mama;
}

struct menu *add_menu(char *n, int x, int y, int height)
{
	struct menu *j = init_menu(n,x,y,height);
	
	if (!mama->f_menu)
		mama->f_menu = mama->l_menu = j;
	else {
		mama->l_menu->n_menu = j;
		mama->l_menu = j;
	}
	return j;

}

void add_menu_button(struct menu *m, char *name, int (*f)())
{
	add_button(m, 0, name, f);	
}

void add_item(struct menu *m, char *name, int (*f)())
{
	struct item *i = init_item(m, name, f);
	if (!m->first || !m->last) {
		i->previous = 0;
		m->first = m->current = m->last = i;
	} else {
		i->previous = m->last;
		m->last->next = i;
		m->last = m->last->next;
	}
}

int menu_key (struct menu *m)
{
	int c = 0, mm = 0;	// current , member 
	do {
		if (c)
			mm = c;
		c = sl_getch();
	} while (c);
	
	if (mm != -1 && (!m->c_click || (mm == '\t' || mm == '\n'))) 
		switch (mm) {
			case '\t':
				if (!m->c_click)
					m->c_click = m->f_click;
				else if (m->c_click->next)
					m->c_click = m->c_click->next;
				else
					m->c_click = 0;
				break;
			case '\n':
				if (m->c_click == 0)
					return m->current->action();
				else
					return m->c_click->action();
			case 'z' :
				return 0;
			break;
			case sl_key_down :
				if (!m->c_click)
					if (m->current->next)
						m->current = m->current->next;
			break;
			case sl_key_up :
				if (!m->c_click)
					if (m->current->previous)
						m->current = m->current->previous;
			break;
			default :
			break;
		};
	if (mm == sl_key_home) {
		if (m->c_click)
			m->c_click = 0;
		else
			m->c_click = m->f_click;
	}
	return 1;
}
void draw_menu(struct menu *m)
{
	if (!m)
		return;
	else {
		struct item *th;
		int y = m->y+1, i, width = m->width-2, height = m->height-2;
		int to_down, to_up;

		// set th -- rewind
		if (m->current == m->first)
			th = m->current;
		else {
			// setting how many item is to up and how many item is to down
			for (to_up = 0, th = m->first; th != m->current; th = th->next, to_up++);
			for (to_down = 0; th; th = th->next, to_down++);
			
			// setting th
			if (to_up <= height/2) 
				th = m->first;
			else if (to_down > height/2)  
				for (th = m->current, to_down = height /2; to_down; 
					th = th->previous, to_down--);
			else 
				for (th = m->current, to_down = height- to_down;
					to_down; th = th->previous, to_down--);
		}
		
		// draw menu
		for (i = 0; i < height && th; th = th->next, y++, i++) {
			if (th == m->current && !m->c_click)
				sl_color(Active);
			else 
				sl_color(Passive);
			sl_goto(m->mama->x + m->x+1, m->mama->y + y);
			sl_addstrn(th->name, width-2);	//for ' ' and <
			sl_putch(' ');
			if (th == m->current) 
				sl_putch(CH_CURRENT_SHOW);
			else if (th == m->first)
				sl_putch(CH_FIRST_SHOW);
			else if (th == m->last)
				sl_putch(CH_LAST_SHOW);
			else 
				sl_putch(' ');
		}
		// draw frame
		sl_color(White);
		sl_frame(m->mama->x+m->x, m->mama->y +m->y, m->width, m->height);
		// set title`s place and draw it
		sl_goto(m->mama->x+ m->x+((width-strlen(m->name))/2), m->mama->y+m->y);
		sl_color(Lwhite);
		sl_addstrn(m->name, sl_strlen_alt(m->name));
		sl_goto(0,0);
		draw_buttons(m->f_click, m->c_click);
	}
}

/*    ******  ********   ** *	         menu stuff			*******  ***** *    */ 
static struct item *init_item(struct menu *m, char *n, int (*f)())
{
	struct item *i = malloc(sizeof(struct item));
	i->next = 0;
	i->action = f;
	if (n)
		i->name = n;
	else
		i->name = "Empty name";
	i->mama = m;
	// perhaps it`s strange but I don`t have other idea . is my english ok. Malekith ?
	if ((int)strlen(i->name)+4 > m->width)
		m->width = put_width(strlen(i->name)+4);
		
		
	return i;		
}

static struct menu* init_menu(char *name, int x, int y, int height)
{
	struct menu *m = malloc(sizeof(struct menu));
	m->last = m->first = 0;
	m->mama = mama;
	m->x = put_x(x);
	m->y = put_y(y);
	m->height = put_height(height+2); // for frame !
	m->width = strlen(name) + 6 ;
	m->name = name;
	m->n_menu = 0;

	m->f_click = m->l_click = m->c_click = 0;
	return m;
}

static int put_x(int x)
{
	if (x > mama->width || x < mama->x)	
		return MENU_X;
	return x;
}

static int put_y(int y)
{
	if (y < mama->y || y > mama->height)
		return MENU_Y;
	return y;
}

static int put_width(int width)
{
	if (width > mama->width || width < mama->x)
		return MENU_WIDTH;
	return width;
}

static int put_height(int height)
{
	if (height > mama->height || height < mama->y)
		return MENU_HEIGHT;
	return height;
}
