
// omentialvo
#include "s_rpass.h"
#include "f_rpass.h"

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>

#include <time.h>
#include <ctype.h>

static char *key;
static char *body;
extern char *pname;
extern char *sdir;
extern char *sname(char *, char *);

struct word;
//-------------------------------------------------------------------------------------
static struct passbot *init_passbot()
{
	// I promise make here list :)
	struct passbot *p = malloc(sizeof(struct passbot));
	p->first = p->last = 0;
	p->n_phrase = 0;

	return p;
}

static char *read_word(FILE *fd, char* to_mask)
{
#define W2 40
	int c = fgetc(fd), width = W2, place = 0;
	char *start = malloc(sizeof(char) * width);
	while (c && c != EOF && !strchr(to_mask,c)) {
		if (place >= width-2)
			start = realloc(start,(width *= 2)+1);
		start[place++] = c;
		c = fgetc(fd);
	}
	start[place] = '\0';
	if (place || c != EOF)
		return start;
	return 0;
}

//-------------------------------------------------------------------------------------
static int set_words(char *whole)
{
	int i;
	while (isspace(*whole) && *whole)
		whole++;
	for (i = 0; whole[i] != ' ' && whole[i]; i++)
		;		
	if (!i)
		return 0;
	body = whole+i+1;
	whole[i] = '\000';
	key = whole;
	return 1;
}

//-----------------------------------------------------------------------------------
static struct word *init_word(char *what)
{
	struct word *w = malloc(sizeof(struct word));
	w->what = what;
	w->next = 0;
	return w;
}

//----------------------------------------------------------------------------------
static struct phrase *init_phrase()
{
	struct phrase *w = malloc(sizeof(struct phrase));
	w->hostile = w->neutral = w->friendly = w->current = 0;
	w->next = w->prev = 0;
	return w;
}

//-------------------------------------------------------------------------------------
struct phrase *add_phrase(struct passbot *p, int state)
{

	if (!p->first) 
		p->first = p->last = init_phrase();
	else {
		p->last->next = init_phrase();
		p->last->next->prev = p->last;
		p->last = p->last->next;
	}
	p->n_phrase++;
	p->last->state = state;
	return p->last;
}

//----------------------------------------------------------------------------------
struct phrase *is_phrase(struct passbot *p, int state)
{
	struct phrase *php = p->first;
	for (; php; php = php->next)
		if (php->state == state)
			return php;
	return 0;
}

//----------------------------------------------------------------------------------
static struct ans *init_ans()
{
	struct ans *a = malloc(sizeof(struct ans));
	a->first = a->last = 0;
	a->next = 0;
	a->n = 0;
	return a;
}

//----------------------------------------------------------------------------------
static void put_ans(struct ans *a, char *what)
{
	if (!a->first) {
		a->first = a->last = init_word(what);
	} else {
		a->last->next = init_word(what);
		a->last = a->last->next;
	}
	a->n++;

}

//----------------------------------------------------------------------------------
char *pprintf(char *s, char *w)
{
	char *ret = malloc(sizeof(char) * (strlen(s) + strlen(w) + 2));
	sprintf(ret,s,w);
	return ret;
}

//-------------------------------------------------------------------------------------
// i know those words should be in array and state should be a index :D
struct passbot *add_passbot(char *fname, int patch) 
{
	char dir[50];
	char *whole_name = sname(sdir, fname);
	FILE *fd = fopen(whole_name,"r");
	struct phrase *p = 0;
	if (!fd) {
		fprintf(stderr, "Can`t open file %s/%s into dir %s\n", 
			dir, fname, getcwd(dir, 50));
		whole_name = sname(PREFIX, fname);
		fd = fopen(whole_name, "r");
		if (!fd) {
			fprintf(stderr, "Can`t open file %s/%s into dir %s\n",	
				sdir, fname, getcwd(dir, 50));
			abort();
		}
	} if (fd) {
		struct passbot *crosser = (patch) ? add_passbot(pname, 0) : init_passbot(); //:)
		int line;
		char *whole, *msg = 0;
		fprintf(stderr,"file %s : ", whole_name);
		for (whole = read_word(fd, "\n"), line = 1;
				whole && !msg; whole = read_word(fd, "\n"), line++) {

			if (!set_words(whole) || *key == '#')
				continue;
			if (*key != '$')
				msg = pprintf("You forgot about $", "");
			else {
				key++;			
				if (!strcmp("keep", key)) {
					p = is_phrase(crosser, KEEP);
					if (!p)
						p = add_phrase(crosser, KEEP);
				} else if (!strcmp("regard", key)) {
					p = is_phrase(crosser, REGARD);
					if (!p)
						p = add_phrase(crosser, REGARD);
				} else if (!strcmp("who", key)) {
					p = is_phrase(crosser, WHO);
					if (!p)
						p = add_phrase(crosser, WHO);
				} else if (!strcmp("be_have", key)) {
					p = is_phrase(crosser, BE_HAVE);
					if (!p)
						p = add_phrase(crosser, BE_HAVE);
				} else if (!strcmp("problem", key)) {
					p = is_phrase(crosser, PROBLEM);
					if (!p)
						p = add_phrase(crosser, PROBLEM);
				} else if (!strcmp("face", key)) {
					p = is_phrase(crosser, FACE);
					if (!p)
						p = add_phrase(crosser, FACE);
				} else if (!strcmp("consent", key)) {
					p = is_phrase(crosser, CONSENT);
					if (!p)
						p = add_phrase(crosser, CONSENT);
				} else if (!strcmp("nice", key)) {
					p = is_phrase(crosser, NICE);
					if (!p)
						p = add_phrase(crosser, NICE);
				} else if (!strcmp("unplea", key)) {
					p = is_phrase(crosser, UNPLEA);
					if (!p)
						p = add_phrase(crosser, UNPLEA);
				} else if (!strcmp("quarrel", key)) {
					p = is_phrase(crosser, QUARREL);
					if (!p)
						p = add_phrase(crosser, QUARREL);
				} else  {
					if (!*key) {
						msg = pprintf("solitary sign '$' ","");
					} else {
						switch (*key) {
							case 'H' :
								if (!p->hostile) 
									p->current = p->hostile 
										= init_ans();
								break;
							case 'N' :
								if (!p->neutral) 
									p->current = p->neutral 
										= init_ans();
								break;
							case 'F' :
								if (!p->friendly) 
									p->current = p->friendly 
										= init_ans();
								break;
						}
						put_ans(p->current, body);
					}
				}
			}
		}
		if (msg)
			fprintf(stderr, "in lines %d is %s", line, msg);
		fprintf(stderr,":D\n");
		return crosser;
	}
	return 0;
}

//-------------------------------------------------------------------------------------
char polish(char c) //pld :)
{
	switch (c) { 
		case '' : return 'a';
		case '' : return 'c';
		case '' : return 'e';
		case '' : return 'l';
		case '' : return 'n';
		case '' : return 'o';
		case '' : return 's';
		case '' :
		case '' : return 'z';
	}
	return c;
}
//-------------------------------------------------------------------------------------
char *small2(char * s)
{
	char *src = malloc(sizeof(char) * (strlen(s)+1));
	strcpy(src,s);
	s = src;
	for (; *src; ++src) {
		*src = tolower(*src);
		*src = polish(*src);
	}
	return s;
}
void smalling(char * src)
{
	for (; *src; ++src) {
		*src = tolower(*src);
		*src = polish(*src);
	}
}
