#include "slang.h"
#include "f_button.h"
#include "f_window.h"
#include "s_button.h"
#include "s_window.h"
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <unistd.h>

static void init_line(struct window *w)
{
	struct line *l = malloc(sizeof(struct line));
	char *c = malloc(sizeof(char)*(w->width+2)); 
	int i = 0;
	l->caption = c;
	while (i <= w->width)
		c[i++] = ' ';
	c[i] = '\000';
	l->length = w->width;
	
	l->nb = ++w->n_lini;
	l->place = 0;
	
	l->next = 0;
	if (!w->first) {
		l->prev = 0;
		w->first = w->last = w->current = l;
		
	} else {
		l->prev = w->last;
		w->last->next = l;
		w->last = l;
	}
}

struct window *init_window(int x, int y, int wi, int h, char *name)
{
	struct window *w = malloc(sizeof(struct window));
	int i = 0;	
	w->name = name;
	w->x = x+1;
	w->y = y+1;
	w->width = wi-2;
	w->height = h-2;
	w->f_click = w->l_click = 0;
	w->first = w->last = 0;
	
	for (;i < w->height; i++)
		init_line(w);
	return w;
}
static struct line * find_line(struct window *w, int nb)
{
	struct line *l = w->current;
	for (;l; l = l->prev)
		if (l->nb == nb)
			return l;
	return 0;
}
static void put_char(struct line *l, int c)
{
	l->caption[l->place++] = c;
}
static void check_and_put_key(struct window *w, int key)
{
	if (!w->current->next) {
		init_line(w);
		w->current = w->last;
	} else
		w->current = w->current->next;
	if (key != '\n' && key != ' ') {
		char *c = &w->current->prev->caption[w->current->length-1];
		int i = w->current->length-1; 
		for (; i+1 && *c != ' '; i--, c--)
			;
		i++;
		if (i) {
			struct line *l = w->current->prev;
			w->current->prev->place = i;// + 1; // for space ' ' 
			i = 0;
			while (i < l->length-l->place) {
				put_char(w->current, l->caption[l->place + i]);
				l->caption[l->place + i++] = ' ';
			}
		}
		put_char(w->current, key);
	}

}
char *chars = "<>ʳӿ?.! *$,/@:;\"+-=%`\n(){}";
void window_key(struct window *w, int key)
{
	if (isdigit(key) || isalpha(key) || strchr(chars, key)) {
		if (w->current->place >= w->current->length || key == '\n')
			check_and_put_key(w, key);
		else
			put_char(w->current, key);
	} else if (key == '\b') {
		clear:
		if (w->current->place) {
			w->current->place--;
			w->current->caption[w->current->place] = ' ';
		} else {
			if (w->current->prev) {
				w->current = w->current->prev;
				goto clear;
			}
		}
	} else if (key == '\t') {
		if (w->f_click)
			w->c_click = w->f_click;
	}
}
static int button_key(struct window *w, int key)
{
	if (key == '\n')
		return action(w->c_click);
	else if (key == '\t' || key == sl_key_right) 
		w->c_click = w->c_click->next;	
	return 1;
		
}
int get_window_key(struct window *w)
{ 
	int key = sl_getch();
	if (key) {
		if (key == sl_key_home) {
			if (w->c_click)
				w->c_click = 0;
			else
				w->c_click = w->f_click;
		} else if (w->c_click)
			return button_key(w, key);
		else
			window_key(w, key);
	}
	return 1;  // it is Typical (from enum type)
}
void add_window_button(struct window *w, char *name, int (*f)())
{
	add_button(0, w, name, f);
	if (w->l_click == w->f_click) {
		w->l_click->x--;
		w->l_click->y++;
	}
	
}
void draw_window(struct window *w)
{
	int y = w->height-1, my = w->y;
	struct line *l = w->current;
	if (l->nb <= w->height)
		l = w->first;
	else
		l = find_line(w, l->nb - w->height+1);
	sl_color(White);
		
	for (y = 0; y < w->height && l; y++,  l = l->next) {
		sl_goto(w->x,w->y+y);
		sl_addstr(l->caption);
		if (l == w->current)
			my += y;
		
	}
	sl_color(White);
	sl_frame(w->x-1, w->y-1, w->width+2, w->height +2);
	sl_goto(w->x-1 + ((w->width+2 - strlen(w->name))/2), w->y-1);
	sl_color(Lwhite);
	sl_addstr(w->name);
	draw_buttons(w->f_click, w->c_click);
	sl_goto(w->x+w->current->place, my);
}
int clear_window(struct window *w)
{
	struct line *l = w->first;
	char *c;
	for (; l; l = l->next) {
		c = l->caption;
		while (*c) 
			*c++ = ' ';
		l->place = 0;
	}
	w->current = w->first;
	w->c_click = 0;
	return 1;
}
